#
#                       lllllll                                         iiii  
#                       l:::::l                                        i::::i 
#                       l:::::l                                         iiii  
#                       l:::::l                                               
#   ppppp   ppppppppp    l::::l uuuuuu    uuuuuu     ggggggggg   gggggiiiiiiinnnn  nnnnnnnn    
#   p::::ppp:::::::::p   l::::l u::::u    u::::u    g:::::::::ggg::::gi:::::in:::nn::::::::nn 
#   p:::::::::::::::::p  l::::l u::::u    u::::u   g:::::::::::::::::g i::::in::::::::::::::nn 
#   pp::::::ppppp::::::p l::::l u::::u    u::::u  g::::::ggggg::::::gg i::::inn:::::::::::::::n
#    p:::::p     p:::::p l::::l u::::u    u::::u  g:::::g     g:::::g  i::::i  n:::::nnnn:::::n
#    p:::::p     p:::::p l::::l u::::u    u::::u  g:::::g     g:::::g  i::::i  n::::n    n::::n
#    p:::::p     p:::::p l::::l u::::u    u::::u  g:::::g     g:::::g  i::::i  n::::n    n::::n
#    p:::::p    p::::::p l::::l u:::::uuuu:::::u  g::::::g    g:::::g  i::::i  n::::n    n::::n
#    p:::::ppppp:::::::pl::::::lu:::::::::::::::uug:::::::ggggg:::::g i::::::i n::::n    n::::n
#    p::::::::::::::::p l::::::l u:::::::::::::::u g::::::::::::::::g i::::::i n::::n    n::::n
#    p::::::::::::::pp  l::::::l  uu::::::::uu:::u  gg::::::::::::::g i::::::i n::::n    n::::n
#    p::::::pppppppp    llllllll    uuuuuuuu  uuuu    gggggggg::::::g iiiiiiii nnnnnn    nnnnnn
#    p:::::p                                                  g:::::g         
#    p:::::p    #plugin on irc.quakenet.org       gggggg      g:::::g         
#   p:::::::p                                     g:::::gg   gg:::::g         
#   p:::::::p                                      g::::::ggg:::::::g         
#   p:::::::p                                       gg:::::::::::::g          
#   ppppppppp                                         ggg::::::ggg            
#                                                        gggggg               
#  Dont Change anything, only when you know what you do!
#
#  ----------------------------------------
#
#  Greetings:
#
#	     thom\mey from #TCL for helping on the Whoami Command.
#	     Mario|awaY for Inspire me to make this Script. :)
#
#  ----------------------------------------
# 
#  Commands:
#
#	    ?IRPG register
#	    ?IRPG class
#	    ?IRPG auth
#	    ?IRPG logout
#	    ?IRPG Join <teamname> [password]
#	    ?IRPG leave
#	    ?IRPG whoami
#
#  ----------------------------------------

	# -- Vars

		set irpg(version)		"1.0.0.1"
		set irpg(autor)			"Julian \'plugin\' K."

		set irpg(authnick)		"Botsworld"
		set irpg(authpass)		"dFaGr54t"

		set irpg(registrate,email)	"botsworld@access-all-areas.name"

		set irpg(channel)		"#irpg"
		set irpg(irpg,botnick)		"IRPG"




	bind PUB n "\?irpg" proc:irpg
	bind msgm - * irpg:check_answer
	bind join - * irpg:auth

	proc irpg:auth {nick host hand chan} {
		
		global irpg

		if {$nick == $::botnick && $chan == $irpg(channel)} {

			putserv "PRIVMSG $irpg(irpg,botnick) :LOGIN $irpg(authnick) $irpg(authpass)"
			putlog "Successfully Authtet to IRPG"

		}

	}

	proc proc:irpg {nick host hand chan arg} {

		global irpg

		set function	[string tolower [lindex [split $arg] 0]]

		switch -- $function {

		  "register" {

			set _irpg(registrate,title)	[lrange [split $arg] 1 end]

			if {$_irpg(registrate,title) == ""} { putserv "PRIVMSG $nick :You must Specifie An Class: ?irpg REGISTER Classname" }

			putserv "PRIVMSG $irpg(irpg,botnick) :REGISTER $irpg(authnick) $irpg(authpass) $irpg(registrate,email) $_irpg(registrate,title)"
			putserv "NOTICE $nick :Done."

		   }

		   "auth" {

			if {![onchan $::botnick $irpg(channel)]} {

				putserv "NOTICE $nick :The Bot is not on $irpg(channel)"
				return
			}

			if {[isop $::botnick $irpg(channel)]} {

				putserv "NOTICE $nick :The Bot is Already Authet."
				return
			}

			putserv "PRIVMSG $irpg(irpg,botnick) :LOGIN $irpg(authnick) $irpg(authpass)"
			putserv "NOTICE $nick :Successfully Authet."

		   }

		   "class" {

			set _irpg(class)	[lrange [split $arg] 1 end]

			if {$_irpg(class) == ""} {

				putserv "NOTICE $nick :You must Specifie The Class: ?irpg CLASS Some Class"
				return
			}

			putserv "PRIVMSG $irpg(irpg,botnick) :CLASS $_irpg(class)"
			putserv "NOTICE $nick :The Class has beeing Successfully Changed to $_irpg(class)"

		   }

		   "logout" {

			if {[onchan $::botnick $irpg(channel)]} {

				putserv "PRIVMSG $irpg(irpg,botnick) :logout"
				putserv "NOTICE $nick :Done."

			}

		   }

		   "join" {

			set _irpg(team,name)		[lindex [split $arg] 1]
			set _irpg(team,password)	[lrange [split $arg] 2 end]

			if {$_irpg(team,name) == ""} { 

				putserv "NOTICE $nick :You must Specifie an Teamname"
				putserv "NOTICE $nick :Example: ?IRPG JOIN \#tcl\.de somepassword"
				return

			}

			if {$_irpg(team,password) == ""} { 

				set $_irpg(team,password) "none"

			}

			if {[onchan $::botnick $irpg(channel)]} {

				putserv "PRIVMSG $irpg(irpg,botnick) :JOIN $_irpg(team,name) $_irpg(team,password)"
				putserv "NOTICE $nick :Done."

			}

		   }

		   "leave" {

			if {![onchan $::botnick $irpg(channel)]} {

				putserv "NOTICE $nick :The bot is not on $irpg(channel), so he cant Leave the Team."
				return

			}

			putserv "PRIVMSG $irpg(irpg,botnick) :LEAVE"
			putserv "NOTICE $nick :Done."

		   }

		   "whoami" {

			set ::irpg(answers) 0
			set ::irpg(replynick) $nick

			putserv "PRIVMSG IRPG :whoami"

		   }

		   "default" {

			putserv "NOTICE $nick :This Command is Unknown to me"

		   }

		}

	}

	proc irpg:check_answer {nick host hand msg} {

		if {![string equal -nocase $nick $::irpg(irpg,botnick)]} { return }

		if {![info exists ::irpg(answers)]} { return }

		if {[regexp -- {^You are (.+?), the level (\d+) (.+?)\. Next level in (.+)\.$} $msg -> ::irpg(user) ::irpg(level) ::irpg(type) ::irpg(nextlevel)]} {

			putlog "Got main irpg info: username: $::irpg(user) level: $::irpg(level) type: $::irpg(type) nextlevel: $::irpg(nextlevel)."

		} elseif {[regexp {^Your itemsum is (\d+)\.$} $msg -> ::irpg(itemsum)]} {

			putlog "Got irpg-itemsum ($::irpg(itemsum))"

		} elseif {[regexp {^You are a member of team (.+)\.$} $msg -> ::irpg(team)]} {

			putlog "Got irpg team: $::irpg(team)."

		} else {

			putlog "Unknown IRPG-reply: \"$msg\""
			return

		}

		incr ::irpg(answers)

		if {$::irpg(answers) >= 2} {

			utimer 3 [list irpg:check_answer $nick $host $hand "You are a member of team none."]

		}

		if {$::irpg(answers) >= 3} {

			putserv "NOTICE $::irpg(replynick) :IRPG-Whoami. \002User:\002 $::irpg(user) \002Level:\002 $::irpg(level) \002Typ:\002 $::irpg(type) \002Next Level in:\002 $::irpg(nextlevel) \002Itemsum:\002 $::irpg(itemsum) \002Team:\002 $::irpg(team)"
		
			unset ::irpg(answers)
			unset ::irpg(replynick)
		}
	}

putlog "IRPG Control Version: $::irpg(version) by $::irpg(autor) Successfully Loaded."